using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PinTrigger : MonoBehaviour
{
    public GameObject placehold;
    public GameObject active;
    public GameObject shard;
    public string triggerTag;
    private bool isTrigger = false;

    void OnTriggerEnter(Collider other) {
        if (other.tag == triggerTag)
        {
            placehold.SetActive(false);
            active.SetActive(true);
            isTrigger = true;
            PinGM.Instance.active = triggerTag;
        }
    }

    void OnTriggerExit(Collider other) {
        if (other.tag == triggerTag)
        {
            placehold.SetActive(true);
            active.SetActive(false);
            isTrigger = false;
            PinGM.Instance.active = null;
        }
    }

    public void SetSuccess() {
        placehold.SetActive(false);
        active.SetActive(false);
        shard.SetActive(false);
        GetComponent<MeshRenderer>().enabled = true;
    }
    
}
